<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <title>uWeaver UI - API documentation : Source: applet/Portal.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link href="styles/bootstrap.css" rel="stylesheet">
    <link href="styles/docs.css" rel="stylesheet">
    <link href="styles/bootstrap-custom.css" rel="stylesheet">
    <link href="http://netdna.bootstrapcdn.com/font-awesome/3.2.1/css/font-awesome.css" rel="stylesheet">
    <script src="http://netdna.bootstrapcdn.com/twitter-bootstrap/2.3.2/js/bootstrap.min.js"></script>
  </head>
  <body>
    <header class="header navbar navbar-inverse">
      <div class="navbar-inner">
        <div class="container-fluid">
          <a class="brand" href="#"><strong>uWeaver UI</strong> API documentation</a>
        </div>
      </div>
    </header>

    <div class="container-fluid">
      <div class="row-fluid">
          <div class="span4">
              <h2><a href="index.html">Index</a></h2><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Modules</li><li><a href="module-boolean.html">boolean</a></li>
<li><a href="module-datetime.html">datetime</a></li>
<li><a href="module-dom.html">dom</a></li>
<li><a href="module-environment.html">environment</a></li>
<li><a href="module-formatter.html">formatter</a></li>
<li><a href="module-i18n.html">i18n</a></li>
<li><a href="module-lang.html">lang</a></li>
<li><a href="module-net.html">net</a></li>
<li><a href="module-number.html">number</a></li>
<li><a href="module-uweaver.html">uweaver</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Classes</li><li><a href="Activities.html"><i class="icon-shield" style="color: #0186d1"></i> Activities</a></li><li><a href="Activity.html"><i class="icon-shield" style="color: #0186d1"></i> Activity</a></li><li><a href="Applet.html"><i class="icon-shield" style="color: #0186d1"></i> Applet</a></li><li><a href="BaseObject.html"><i class="icon-shield" style="color: #0186d1"></i> BaseObject</a></li><li><a href="Button.html"><i class="icon-shield" style="color: #0186d1"></i> Button</a></li><li><a href="CartesianChart.html"><i class="icon-shield" style="color: #0186d1"></i> CartesianChart</a></li><li><a href="Checkbox.html"><i class="icon-shield" style="color: #0186d1"></i> Checkbox</a></li><li><a href="Collection.html"><i class="icon-shield" style="color: #0186d1"></i> Collection</a></li><li><a href="Combobox.html"><i class="icon-shield" style="color: #0186d1"></i> Combobox</a></li><li><a href="Container.html"><i class="icon-shield" style="color: #0186d1"></i> Container</a></li><li><a href="Datebox.html"><i class="icon-shield" style="color: #0186d1"></i> Datebox</a></li><li><a href="Datepicker.html"><i class="icon-shield" style="color: #0186d1"></i> Datepicker</a></li><li><a href="Filebox.html"><i class="icon-shield" style="color: #0186d1"></i> Filebox</a></li><li><a href="Filedropper.html"><i class="icon-shield" style="color: #0186d1"></i> Filedropper</a></li><li><a href="Form.html"><i class="icon-shield" style="color: #0186d1"></i> Form</a></li><li><a href="Gadget.html"><i class="icon-shield" style="color: #0186d1"></i> Gadget</a></li><li><a href="Grid.html"><i class="icon-shield" style="color: #0186d1"></i> Grid</a></li><li><a href="Icon.html"><i class="icon-shield" style="color: #0186d1"></i> Icon</a></li><li><a href="Inputbox.html"><i class="icon-shield" style="color: #0186d1"></i> Inputbox</a></li><li><a href="Item.html"><i class="icon-shield" style="color: #0186d1"></i> Item</a></li><li><a href="Json.html"><i class="icon-shield" style="color: #0186d1"></i> Json</a></li><li><a href="Logger.html"><i class="icon-shield" style="color: #0186d1"></i> Logger</a></li><li><a href="MDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> MDIApplet</a></li><li><a href="Memory.html"><i class="icon-shield" style="color: #0186d1"></i> Memory</a></li><li><a href="Menu.html"><i class="icon-shield" style="color: #0186d1"></i> Menu</a></li><li><a href="Model.html"><i class="icon-shield" style="color: #0186d1"></i> Model</a></li><li><a href="Numberbox.html"><i class="icon-shield" style="color: #0186d1"></i> Numberbox</a></li><li><a href="Pagination.html"><i class="icon-shield" style="color: #0186d1"></i> Pagination</a></li><li><a href="Panel.html"><i class="icon-shield" style="color: #0186d1"></i> Panel</a></li><li><a href="PolarChart.html"><i class="icon-shield" style="color: #0186d1"></i> PolarChart</a></li><li><a href="Popup.html"><i class="icon-shield" style="color: #0186d1"></i> Popup</a></li><li><a href="Portal.html"><i class="icon-shield" style="color: #0186d1"></i> Portal</a></li><li><a href="Proxy.html"><i class="icon-shield" style="color: #0186d1"></i> Proxy</a></li><li><a href="Radiobutton.html"><i class="icon-shield" style="color: #0186d1"></i> Radiobutton</a></li><li><a href="Reader.html"><i class="icon-shield" style="color: #0186d1"></i> Reader</a></li><li><a href="Selectbox.html"><i class="icon-shield" style="color: #0186d1"></i> Selectbox</a></li><li><a href="Site.html"><i class="icon-shield" style="color: #0186d1"></i> Site</a></li><li><a href="Sites.html"><i class="icon-shield" style="color: #0186d1"></i> Sites</a></li><li><a href="Store.html"><i class="icon-shield" style="color: #0186d1"></i> Store</a></li><li><a href="TabPanel.html"><i class="icon-shield" style="color: #0186d1"></i> TabPanel</a></li><li><a href="TDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> TDIApplet</a></li><li><a href="Testbench.html"><i class="icon-shield" style="color: #0186d1"></i> Testbench</a></li><li><a href="Testlet.html"><i class="icon-shield" style="color: #0186d1"></i> Testlet</a></li><li><a href="Textbox.html"><i class="icon-shield" style="color: #0186d1"></i> Textbox</a></li><li><a href="Toolbox.html"><i class="icon-shield" style="color: #0186d1"></i> Toolbox</a></li><li><a href="Trigger.html"><i class="icon-shield" style="color: #0186d1"></i> Trigger</a></li><li><a href="Triggers.html"><i class="icon-shield" style="color: #0186d1"></i> Triggers</a></li><li><a href="User.html"><i class="icon-shield" style="color: #0186d1"></i> User</a></li><li><a href="Users.html"><i class="icon-shield" style="color: #0186d1"></i> Users</a></li><li><a href="Violation.html"><i class="icon-shield" style="color: #0186d1"></i> Violation</a></li><li><a href="Widget.html"><i class="icon-shield" style="color: #0186d1"></i> Widget</a></li><li><a href="WindowManager.html"><i class="icon-shield" style="color: #0186d1"></i> WindowManager</a></li><li><a href="Workbench.html"><i class="icon-shield" style="color: #0186d1"></i> Workbench</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Global</li><li><a href="global.html#_anchors"><i class="icon-globe" style="color: black;"></i> _anchors</a></li><li><a href="global.html#_form"><i class="icon-globe" style="color: black;"></i> _form</a></li><li><a href="global.html#_interact"><i class="icon-globe" style="color: black;"></i> _interact</a></li><li><a href="global.html#_marker"><i class="icon-globe" style="color: black;"></i> _marker</a></li><li><a href="global.html#_tabPanel"><i class="icon-globe" style="color: black;"></i> _tabPanel</a></li><li><a href="global.html#browse"><i class="icon-globe" style="color: black;"></i> browse</a></li><li><a href="global.html#draggable"><i class="icon-globe" style="color: black;"></i> draggable</a></li><li><a href="global.html#events"><i class="icon-globe" style="color: black;"></i> events</a></li><li><a href="global.html#initialize"><i class="icon-globe" style="color: black;"></i> initialize</a></li><li><a href="global.html#layout"><i class="icon-globe" style="color: black;"></i> layout</a></li><li><a href="global.html#logger"><i class="icon-globe" style="color: black;"></i> logger</a></li><li><a href="global.html#login"><i class="icon-globe" style="color: black;"></i> login</a></li><li><a href="global.html#onDragstart"><i class="icon-globe" style="color: black;"></i> onDragstart</a></li><li><a href="global.html#onTabsActivate"><i class="icon-globe" style="color: black;"></i> onTabsActivate</a></li><li><a href="global.html#onTaskSelect"><i class="icon-globe" style="color: black;"></i> onTaskSelect</a></li><li><a href="global.html#perform"><i class="icon-globe" style="color: black;"></i> perform</a></li><li><a href="global.html#prepare"><i class="icon-globe" style="color: black;"></i> prepare</a></li><li><a href="global.html#requirejs"><i class="icon-globe" style="color: black;"></i> requirejs</a></li><li><a href="global.html#start"><i class="icon-globe" style="color: black;"></i> start</a></li><li><a href="global.html#toUrl"><i class="icon-globe" style="color: black;"></i> toUrl</a></li><li><a href="global.html#validate"><i class="icon-globe" style="color: black;"></i> validate</a></li></ul></div>
          </div>

          <div class="span8">
              <h1 class="page-header">Source: applet/Portal.js</h1>
              


    
    <section>
        <article>
            <pre class="prettyprint source"><code>/**
 * @license
 * This document is a part of the source code and related artifacts
 * for uWeaver, an open source application development framework for
 * Enterprise Application Software.
 *
 *      http://www.uweaver.org
 *
 * Copyright 2014 Jason Lin
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

define(['underscore', 'jquery', 'uweaver/lang',
    'uweaver/widget/Widget', 'uweaver/applet/Gadget', 'uweaver/data/Collection', 'uweaver/widget/Triggers',
    'uweaver/widget/Popup', 'uweaver/widget/Panel',
    'uweaver/exception/UnsupportedTypeException',
    'text!./tpl/Portal.html', 'text!./tpl/Portal/LayoutSelector.html', 'text!./tpl/Portal/ContentSelector.html',
    'uweaver/Logger'], function (_, $, lang, Widget, Gadget, Collection, Triggers, Popup, Panel, UnsupportedTypeException,
                                 tpl, tplLayoutSelector, tplGadgetSelector, Logger) {

    var declare = lang.declare;
    var Base = Widget;
    var LOGGER = new Logger("uweaver/applet/Portal");

    var LayoutSelector = declare(Popup, {
        initialize: function(config) {
            Popup.prototype.initialize.apply(this, arguments);
            var defaults = {
                tpl: tplLayoutSelector
            };
            var cfg = this._cfg;
            _.defaults(cfg, defaults);

            this._data = (cfg.data) ? cfg.data : new Collection();

            this._triggers = new Triggers({
                el: this.$('[name=toolbar]')
            }).render();

            this.listenTo(this._trigger, 'trigger', _.bind(this.onTrigger, this));
        },

        onTrigger: function(e) {
            var event = {
                data: this._listbox.selection()
            };
            this.trigger('select', {

            });
        }
    }, {
        _data: undefined,
        _triggers: undefined
    });
    var GadgetSelector = declare(Panel, {
        initialize: function(config) {
            Panel.prototype.initialize.apply(this, arguments);
            var defaults = {
                tpl: tplGadgetSelector
            };
            var cfg = this._cfg;
            _.defaults(cfg, defaults);
        }
    });

    /**
     * An applet is an application for one specific activity.
     *
     * ##### Usage
     *     var applet = new Portal({
     *         el: $('#applet')
     *     });
     *     applet.render();
     *
     *     var messages = new Gadget({
     *         tpl: "&lt;h3>Messages&lt;/h3>&lt;p>Here are messages for you ...&lt;/p>"
     *         title: "Messages",
     *         badge: "3"
     *     }).render();
     *
     *     applet.add(messages);
     *
     * ##### Events:
     * + 'select' - [select()]{@link Portal#select}, [add()]{@link Portal#add}, [remove()]{@link Portal#remove}
     * + 'add' - [add()]{@link Portal#add}
     * + 'remove' - [remove()]{@link Portal#remove}
     * + 'transition:menu' - [menu()]{@link Portal#menu}, [title()]{@link Portal#title}
     *
     * @constructor Portal
     * @extends Widget
     * @author  Jason Lin
     * @since   1.0
     * @param {Object} [config] - The configuration of the applet.
     * @param {String} [config.tpl] - A html string to layout &amp; construct the DOM.
     * @param {String} [config.title] - The title of the applet.
     */
    function initialize(config) {
        Base.prototype.initialize.apply(this, arguments);

        var defaults = {
            tpl: tpl
        };
        var cfg = this._cfg;

        _.defaults(cfg, defaults);

        this._title = cfg.title;

        this._gadgets = (cfg.gadgets) ? cfg.gadgets : new Collection();
        this._layouts = (cfg.layouts) ? cfg.layouts : new Collection();

        this._layoutSelector = new LayoutSelector({
            data: this._layouts
        });

        this.listenTo(this._layoutSelector, 'select', _.bind(onSelectLayout, this));

        this._gadgetSelector = new GadgetSelector({
            data: this._gadgets
        });

        this.listenTo(this._gadgetSelector, 'select', _bind(onSelectGadget, this));
    }

    /**
     * @override
     */
    function render(options) {
        Base.prototype.render.apply(this, arguments);

        var defaults = {
            hidden: false
        };
        var cfg = this.cfg();

        options || (options = {});
        _.defaults(options, defaults);

        var anchors = this._anchors;

        var toolbar = new Triggers({
            el: this.$('[name=toolbar]'),
            selector: "i"
        }).render();

        this.listenTo(toolbar, 'trigger', onCommandTrigger);

        this._toolbar = toolbar;

        this._layoutSelector.render({hidden: true});
        this._contentSelector.render({hidden: true});

        if(this.render === render) {
            this._isRendered = true;

            this.trigger('rendered', {
                data: {},
                context: this,
                source: this
            });
            options.hidden || this.show();
        }

        return this;
    }

    function onCommandTrigger(event) {
        var value = event.data.value;

        switch (value.toUpperCase()) {
            case Portal.COMMAND.LAYOUT:
                this._layoutSelector.show();
                break;
            case Portal.COMMAND.CUSTOMIZE:
                this._gadgetSelector.hide();
                break;
            default:
                break;
        }
    }

    function layout() {

    }

    function isSingleton() {
        return this._singleton;
    }

    function start() {
        this.render();

        var event = {
            data: {},
            context: this,
            source: this
        };
        this.trigger('start', event);
    }

    function stop() {
        var event = {
            data: {},
            context: this,
            source: this
        };
        this.trigger('stop', event);
        this.destroy();
    }

    function pid() {
        return this.oid();
    }

    /**
     * Get or set the title of the applet.
     *
     * ##### Events:
     * - 'transition:title' => triggered after title changed.
     *
     * @memberof Portal#
     * @param {Object} [text] - the title.
     * @param {Object} [options] - A map of additional options to pass to the method.
     * @param {Boolean} [options.silent=false] - A true value will prevent the events from being triggered.
     * @returns {String}
     */
    function title(text, options) {
        if(!text) return this._title;

        this._title = text;

        options || (options = {});

        options.silent || this.trigger('transition', {
            context: this,
            source: this,
            data: undefined
        });
    }

    /**
     *
     * Get or set the menu.
     *
     * ##### Events:
     * - 'transition:menu' => triggered after menu changed. event.data => the menu.
     *
     * @memberof Portal#
     * @param {Triggers} triggers - the menu.
     * @param {Object} [options] - A map of additional options to pass to the method.
     * @param {Boolean} [options.silent=false] - A true value will prevent the events from being triggered.
     * @returns {Triggers}
     *
     */
    function menu(triggers, options) {
        if(!triggers) return this._menu;

        options || (options = {});

        this._menu = triggers;
        options.silent || this.trigger('transition:menu', {
            context: this,
            source: this,
            data: this._menu
        });
    }

    /**
     * Add the gadget to the applet.

     * ##### Events:
     * + 'add' - triggered after added. event.data => the added gadget.
     * + 'select' - triggered after new gadget selected. event.data => the selected gadget.
     *
     * @memberof Portal#
     * @param {Gadget} gadget - The gadget to add.
     * @param {Object} [options] - A map of additional options to pass to the method.
     * @param {Boolean} [options.silent=false] - A true value will prevent the events from being triggered.
     * @returns {Portal} this
     */
    function add(gadget, options) {
        if(!(gadget instanceof Gadget)) {
            throw new UnsupportedTypeException({
                supportedTypes: ['Gadget'],
                type: typeof gadget
            });
        }

        options || (options = {});

        var defaults = {
            selected: true,
            title: gadget.title()
        };

        _.defaults(options, defaults);

        this.listenTo(gadget, 'transition', _.bind(onGadgeTransition, this));

        return this;
    }

    /**
     * @todo update the tab's content(title &amp; badge)
     * @param event
     */
    function onGadgeTransition(event) {
        var gadget = event.context;
    }

    /**
     * Remove the gadget from the applet.
     *
     * ##### Events:
     * + 'remove' - triggered after removed. event.data => the removed gadget.
     * + 'select' - triggered after new gadget selected. event.data => the selected gadget.
     *
     * @memberof Portal#
     * @param {Gadget} gadget - The gadget to remove.
     * @param {Object} [options] - A map of additional options to pass to the method.
     * @param {Boolean} [options.silent=false] - A true value will prevent the events from being triggered.
     * @returns {Portal} this
     */
    function remove(gadget, options) {
        options || (options = {});
        this.stopListening(gadget);
        return this;
    }

    /**
     * Remove all gadgets from the applet.
     *
     * ##### Events:
     * + 'remove' - triggered after removed.
     *
     * @memberof Portal#
     * @param {Object} [options] - A map of additional options to pass to the method.
     * @param {Boolean} [options.silent=false] - A true value will prevent the events from being triggered.
     * @returns {Portal} this
     */
    function removeAll(options) {
        options || (options = {});
        _.each(this.gadgets(), function(gadget) {
            this.stopListening(gadget);
        }, this);
        return this;
    }

    /**
     * Select the gadget to show.
     *
     * ##### Events:
     * + 'select' - triggered after selected. event.data => the selected gadget.
     *
     * @memberof Portal#
     * @param {Gadget|Integer} gadget - The gadget(or index of the gadget) to show.
     * @param {Object} [options] - A map of additional options to pass to the method.
     * @param {Boolean} [options.silent=false] - A true value will prevent the events from being triggered.
     * @returns {Portal} this
     */
    function select(gadget, options) {

        return this;
    }

    /**
     * Get the gadget.
     *
     * @memberof Portal#
     * @param {Integer} index - The index of gadget. zero-based.
     * @returns {Gadget}
     */
    function get(index) {
    }

    /**
     * Get the active gadget.
     *
     * @memberof Portal#
     * @returns {Gadget}
     */
    function current() {
    }

    /**
     * Get the # of gadgets.
     *
     * @memberof Portal#
     * @returns {Integer}
     */
    function size() {
    }

    /**
     * Get all gadgets.
     *
     * @memberof Portal#
     * @returns {Integer}
     */
    function gadgets() {
    }


    var props = {
        _singleton: false,
        _menu: undefined,
        _title: undefined,
        _maxZIndex: 0,
        _gadgets: undefined,
        _activeGadget: undefined,
        className: "container",
        _porlets: undefined,
        _layouts: undefined,
        _triggers: undefined
    };

    var Portal = declare(Base, {
        initialize: initialize,
        render: render,
        menu: menu,
        isSingleton: isSingleton,
        start: start,
        stop: stop,
        pid: pid,
        title: title,
        add: add,
        remove: remove,
        removeAll: removeAll,
        select: select,
        get: get,
        current: current,
        size: size,
        gadgets: gadgets,
        layout: layout
    }, props);

    Portal.COMMAND = {
        LAYOUT: 'LAYOUT',
        CUSTOMIZE: 'CUSTOMIZE'
    };

    return Portal;
});</code></pre>
        </article>
    </section>




          </div>
      </div>

        <br clear="both">

      <footer>
        Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.3.2</a> on Fri Aug 26 2016 10:58:19 GMT+0800 (CST)
        <br>
      </footer>
      <script> prettyPrint(); </script>
    </div>
  </body>
</html>
